// Populate the sidebar
//
// This is a script, and not included directly in the page, to control the total size of the book.
// The TOC contains an entry for each page, so if each page includes a copy of the TOC,
// the total size of the page becomes O(n**2).
class MDBookSidebarScrollbox extends HTMLElement {
    constructor() {
        super();
    }
    connectedCallback() {
        this.innerHTML = '<ol class="chapter"><li class="chapter-item expanded affix "><a href="index.html">Linux for ARM</a></li><li class="chapter-item expanded affix "><a href="foreword.html">Предисловие</a></li><li class="chapter-item expanded affix "><a href="from-authors.html">От авторов</a></li><li class="chapter-item expanded affix "><a href="benefits.html">Преимущества</a></li><li class="chapter-item expanded affix "><a href="before-start.html">Прежде чем начать</a></li><li class="chapter-item expanded affix "><a href="typography.html">Принятые обозначения</a></li><li class="chapter-item expanded affix "><a href="inaccuracies.html">Опечатки и неточности</a></li><li class="chapter-item expanded affix "><a href="arch.html">Целевая архитектура</a></li><li class="chapter-item expanded affix "><a href="software.html">Информация об используемом ПО</a></li><li class="chapter-item expanded "><a href="prepare/index.html"><strong aria-hidden="true">1.</strong> Подготовка к сборке</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="prepare/requrements.html"><strong aria-hidden="true">1.1.</strong> Требования к хосту</a></li><li class="chapter-item expanded "><a href="prepare/about-sbu.html"><strong aria-hidden="true">1.2.</strong> О времени сборки пакетов</a></li><li class="chapter-item expanded "><a href="prepare/add-user.html"><strong aria-hidden="true">1.3.</strong> Создание пользователя lfa</a></li><li class="chapter-item expanded "><a href="prepare/set-env.html"><strong aria-hidden="true">1.4.</strong> Настройка окружения</a></li><li class="chapter-item expanded "><a href="prepare/set-build-env.html"><strong aria-hidden="true">1.5.</strong> Установка переменных сборки</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="prepare/set-build-env-aarch64.html"><strong aria-hidden="true">1.5.1.</strong> Для архитектуры AArch64</a></li><li class="chapter-item expanded "><a href="prepare/set-build-env-other.html"><strong aria-hidden="true">1.5.2.</strong> Для других архитектур</a></li></ol></li><li class="chapter-item expanded "><a href="prepare/create-dirs.html"><strong aria-hidden="true">1.6.</strong> Создание основных каталогов</a></li><li class="chapter-item expanded "><a href="prepare/download-packages.html"><strong aria-hidden="true">1.7.</strong> Скачивание пакетов</a></li></ol></li><li class="chapter-item expanded "><a href="cross-compiler/index.html"><strong aria-hidden="true">2.</strong> Сборка кросс-компилятора</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="cross-compiler/linux-headers.html"><strong aria-hidden="true">2.1.</strong> linux-headers</a></li><li class="chapter-item expanded "><a href="cross-compiler/binutils.html"><strong aria-hidden="true">2.2.</strong> binutils</a></li><li class="chapter-item expanded "><a href="cross-compiler/gcc-p1.html"><strong aria-hidden="true">2.3.</strong> gcc (проход 1)</a></li><li class="chapter-item expanded "><a href="cross-compiler/musl.html"><strong aria-hidden="true">2.4.</strong> musl</a></li><li class="chapter-item expanded "><a href="cross-compiler/gcc-p2.html"><strong aria-hidden="true">2.5.</strong> gcc (проход 2)</a></li><li class="chapter-item expanded "><a href="cross-compiler/check.html"><strong aria-hidden="true">2.6.</strong> Проверка кросс-компилятора</a></li><li class="chapter-item expanded "><a href="cross-compiler/cleanup.html"><strong aria-hidden="true">2.7.</strong> Очистка и сохранение</a></li><li class="chapter-item expanded "><a href="cross-compiler/env.html"><strong aria-hidden="true">2.8.</strong> Объявление дополнительных переменных</a></li></ol></li><li class="chapter-item expanded "><a href="base/index.html"><strong aria-hidden="true">3.</strong> Сборка базовой системы</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="base/create-files.html"><strong aria-hidden="true">3.1.</strong> Создание файлов и каталогов</a></li><li class="chapter-item expanded "><a href="base/libgcc.html"><strong aria-hidden="true">3.2.</strong> libgcc</a></li><li class="chapter-item expanded "><a href="base/musl.html"><strong aria-hidden="true">3.3.</strong> musl</a></li><li class="chapter-item expanded "><a href="base/busybox.html"><strong aria-hidden="true">3.4.</strong> busybox</a></li><li class="chapter-item expanded "><a href="base/iana-etc.html"><strong aria-hidden="true">3.5.</strong> iana-etc</a></li><li class="chapter-item expanded "><a href="base/wireless-tools.html"><strong aria-hidden="true">3.6.</strong> wireless-tools</a></li></ol></li><li class="chapter-item expanded "><a href="set-base/index.html"><strong aria-hidden="true">4.</strong> Настройка базовой системы</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="set-base/fstab.html"><strong aria-hidden="true">4.1.</strong> Создание /etc/fstab</a></li><li class="chapter-item expanded "><a href="set-base/mdev.html"><strong aria-hidden="true">4.2.</strong> Настройка mdev</a></li><li class="chapter-item expanded "><a href="set-base/profile.html"><strong aria-hidden="true">4.3.</strong> Создание /etc/profile</a></li><li class="chapter-item expanded "><a href="set-base/hostname.html"><strong aria-hidden="true">4.4.</strong> Установка имени хоста</a></li><li class="chapter-item expanded "><a href="set-base/network.html"><strong aria-hidden="true">4.5.</strong> Настройка сети</a></li></ol></li><li class="chapter-item expanded "><a href="kernel/index.html"><strong aria-hidden="true">5.</strong> Сборка ядра</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="kernel/linux.html"><strong aria-hidden="true">5.1.</strong> linux</a></li></ol></li><li class="chapter-item expanded "><a href="bootloader/index.html"><strong aria-hidden="true">6.</strong> Сборка загрузчика</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="bootloader/allwinner.html"><strong aria-hidden="true">6.1.</strong> Allwinner</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="bootloader/allwinner-tf-a.html"><strong aria-hidden="true">6.1.1.</strong> Сборка TF-A</a></li><li class="chapter-item expanded "><a href="bootloader/allwinner-or2k-cc.html"><strong aria-hidden="true">6.1.2.</strong> Установка кросс-компилятора or2k</a></li><li class="chapter-item expanded "><a href="bootloader/allwinner-crust.html"><strong aria-hidden="true">6.1.3.</strong> Сборка SCP (crust)</a></li><li class="chapter-item expanded "><a href="bootloader/allwinner-uboot.html"><strong aria-hidden="true">6.1.4.</strong> Сборка U-Boot</a></li></ol></li><li class="chapter-item expanded "><a href="bootloader/broadcom.html"><strong aria-hidden="true">6.2.</strong> Broadcom</a></li><li class="chapter-item expanded "><a href="bootloader/rockchip.html"><strong aria-hidden="true">6.3.</strong> Rockchip</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="bootloader/rockchip-tf-a.html"><strong aria-hidden="true">6.3.1.</strong> Сборка TF-A/rkbin</a></li><li class="chapter-item expanded "><a href="bootloader/rockchip-tpl.html"><strong aria-hidden="true">6.3.2.</strong> TPL</a></li><li class="chapter-item expanded "><a href="bootloader/rockchip-uboot.html"><strong aria-hidden="true">6.3.3.</strong> Сборка U-Boot</a></li></ol></li><li class="chapter-item expanded "><a href="bootloader/qemu.html"><strong aria-hidden="true">6.4.</strong> Эмуляция в QEMU (ARM)</a></li></ol></li><li class="chapter-item expanded "><a href="boot-files/index.html"><strong aria-hidden="true">7.</strong> Создание прочих загрузочных файлов</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="boot-files/bootscripts.html"><strong aria-hidden="true">7.1.</strong> Загрузочные скрипты</a></li><li class="chapter-item expanded "><a href="boot-files/uInitrd.html"><strong aria-hidden="true">7.2.</strong> Создание uInitrd</a></li><li class="chapter-item expanded "><a href="boot-files/boot.scr.html"><strong aria-hidden="true">7.3.</strong> Создание boot.scr</a></li></ol></li><li class="chapter-item expanded "><a href="create-img.html"><strong aria-hidden="true">8.</strong> Сборка образа</a></li><li class="chapter-item expanded "><a href="next.html"><strong aria-hidden="true">9.</strong> Что далее?</a></li><li class="chapter-item expanded "><a href="additional/index.html"><strong aria-hidden="true">10.</strong> Вспомогательные материалы</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="additional/arm.html"><strong aria-hidden="true">10.1.</strong> Процессоры ARM</a></li><li class="chapter-item expanded "><a href="additional/os-structure.html"><strong aria-hidden="true">10.2.</strong> Заметки об ОС Linux</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="additional/os-structure1.html"><strong aria-hidden="true">10.2.1.</strong> Часть 1</a></li><li class="chapter-item expanded "><a href="additional/os-structure2.html"><strong aria-hidden="true">10.2.2.</strong> Часть 2</a></li><li class="chapter-item expanded "><a href="additional/os-structure3.html"><strong aria-hidden="true">10.2.3.</strong> Часть 3</a></li><li class="chapter-item expanded "><a href="additional/os-structure4.html"><strong aria-hidden="true">10.2.4.</strong> Часть 4</a></li></ol></li><li class="chapter-item expanded "><a href="additional/pkgmgt.html"><strong aria-hidden="true">10.3.</strong> Управление пакетами</a></li><li class="chapter-item expanded "><a href="additional/compile.html"><strong aria-hidden="true">10.4.</strong> Сборка ПО из исходного кода</a></li><li class="chapter-item expanded "><a href="additional/cross-compiler.html"><strong aria-hidden="true">10.5.</strong> Кросс-компилятор</a></li><li class="chapter-item expanded "><a href="additional/fpu.html"><strong aria-hidden="true">10.6.</strong> FPU в ARM-процессорах</a></li><li class="chapter-item expanded "><a href="additional/dtb.html"><strong aria-hidden="true">10.7.</strong> Device Tree</a></li><li class="chapter-item expanded "><a href="additional/u-boot/index.html"><strong aria-hidden="true">10.8.</strong> Загрузчик U-Boot</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="additional/u-boot/env-vars.html"><strong aria-hidden="true">10.8.1.</strong> Переменные окружения</a></li><li class="chapter-item expanded "><a href="additional/u-boot/dtbo.html"><strong aria-hidden="true">10.8.2.</strong> Загрузка DTBO</a></li><li class="chapter-item expanded "><a href="additional/u-boot/partitions.html"><strong aria-hidden="true">10.8.3.</strong> Разделы загрузочного носителя</a></li></ol></li></ol></li><li class="chapter-item expanded "><a href="appendix/index.html"><strong aria-hidden="true">11.</strong> Приложения</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="appendix/computers.html"><strong aria-hidden="true">11.1.</strong> Список ПК, на которых собиралась LFA</a></li><li class="chapter-item expanded "><a href="appendix/scripts/index.html"><strong aria-hidden="true">11.2.</strong> Загрузочные скрипты и конфигурационные файлы</a></li><li><ol class="section"><li class="chapter-item expanded "><a href="appendix/scripts/rc.d-shutdown.html"><strong aria-hidden="true">11.2.1.</strong> /etc/rc.d/shutdown</a></li><li class="chapter-item expanded "><a href="appendix/scripts/rc.d-startup.html"><strong aria-hidden="true">11.2.2.</strong> /etc/rc.d/startup</a></li><li class="chapter-item expanded "><a href="appendix/scripts/rc.d-init.d-functions.html"><strong aria-hidden="true">11.2.3.</strong> /etc/rc.d/init.d/functions</a></li><li class="chapter-item expanded "><a href="appendix/scripts.rc.d-scripts.html"><strong aria-hidden="true">11.2.4.</strong> /etc/rc.d/init.d/scripts/</a></li></ol></li></ol></li><li class="chapter-item expanded "><a href="literature.html"><strong aria-hidden="true">12.</strong> Литература</a></li><li class="chapter-item expanded affix "><li class="spacer"></li><li class="chapter-item expanded "><a href="roadmap.html"><strong aria-hidden="true">13.</strong> Roadmap</a></li><li class="chapter-item expanded "><a href="whatsnew.html"><strong aria-hidden="true">14.</strong> Что нового в этом релизе</a></li><li class="chapter-item expanded "><a href="changelog.html"><strong aria-hidden="true">15.</strong> Список изменений</a></li></ol>';
        // Set the current, active page, and reveal it if it's hidden
        let current_page = document.location.href.toString();
        if (current_page.endsWith("/")) {
            current_page += "index.html";
        }
        var links = Array.prototype.slice.call(this.querySelectorAll("a"));
        var l = links.length;
        for (var i = 0; i < l; ++i) {
            var link = links[i];
            var href = link.getAttribute("href");
            if (href && !href.startsWith("#") && !/^(?:[a-z+]+:)?\/\//.test(href)) {
                link.href = path_to_root + href;
            }
            // The "index" page is supposed to alias the first chapter in the book.
            if (link.href === current_page || (i === 0 && path_to_root === "" && current_page.endsWith("/index.html"))) {
                link.classList.add("active");
                var parent = link.parentElement;
                if (parent && parent.classList.contains("chapter-item")) {
                    parent.classList.add("expanded");
                }
                while (parent) {
                    if (parent.tagName === "LI" && parent.previousElementSibling) {
                        if (parent.previousElementSibling.classList.contains("chapter-item")) {
                            parent.previousElementSibling.classList.add("expanded");
                        }
                    }
                    parent = parent.parentElement;
                }
            }
        }
        // Track and set sidebar scroll position
        this.addEventListener('click', function(e) {
            if (e.target.tagName === 'A') {
                sessionStorage.setItem('sidebar-scroll', this.scrollTop);
            }
        }, { passive: true });
        var sidebarScrollTop = sessionStorage.getItem('sidebar-scroll');
        sessionStorage.removeItem('sidebar-scroll');
        if (sidebarScrollTop) {
            // preserve sidebar scroll position when navigating via links within sidebar
            this.scrollTop = sidebarScrollTop;
        } else {
            // scroll sidebar to current active section when navigating via "next/previous chapter" buttons
            var activeSection = document.querySelector('#sidebar .active');
            if (activeSection) {
                activeSection.scrollIntoView({ block: 'center' });
            }
        }
        // Toggle buttons
        var sidebarAnchorToggles = document.querySelectorAll('#sidebar a.toggle');
        function toggleSection(ev) {
            ev.currentTarget.parentElement.classList.toggle('expanded');
        }
        Array.from(sidebarAnchorToggles).forEach(function (el) {
            el.addEventListener('click', toggleSection);
        });
    }
}
window.customElements.define("mdbook-sidebar-scrollbox", MDBookSidebarScrollbox);
